﻿using Syncfusion.SfAutoComplete.XForms;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AutoComplete
{
    class CustomAutoComplete : SfAutoComplete
    {
        public Reason _Reason
        {
            get;
            set;
        }

        private bool _AllowChangeReason = true;

        public CustomAutoComplete() : base()
        {
            this.SuggestionMode = SuggestionMode.Contains;
            List<String> countryNames = new List<String>();
            countryNames.Add("Uganda");
            countryNames.Add("Ukraine");
            countryNames.Add("Canada");
            countryNames.Add("United Arab Emirates");
            countryNames.Add("France");
            countryNames.Add("United Kingdom");
            countryNames.Add("China");
            countryNames.Add("United States");
            countryNames.Add("Japan");
            this.DataSource = countryNames;
          
            this.SelectionChanged += CustomAutoComplete_SelectionChanged;
            this.ValueChanged += CustomAutoComplete_ValueChanged;
            _Reason = Reason.User;
        }

        private void CustomAutoComplete_ValueChanged(object sender, ValueChangedEventArgs e)
        {
            if (_AllowChangeReason)
            {
                if (_Reason == Reason.Suggestion)
                {
                    _Reason = Reason.User;
                }
            }
        }

    

    private void CustomAutoComplete_SelectionChanged(object sender, SelectionChangedEventArgs e)
    {
        _Reason = Reason.Suggestion;
        _AllowChangeReason = false;


            Xamarin.Forms.Device.StartTimer(TimeSpan.FromSeconds(1), (() =>
             {
                 _AllowChangeReason = true;
                 return false;
             }));
        }
}

enum Reason
{
    Suggestion, User
}
}